package sovellus;


public class IntJoukko {


    public final static int KAPASITEETTI = 5;   
    public final static int OLETUSKASVATUS = 5; 
    private int[] taulukko;                     
    private int alkioidenLkm;
    private int kasvatuskoko;                   

    public IntJoukko(int kapasiteetti, int kasvatuskoko) {
        this.taulukko = new int[kapasiteetti];
        this.kasvatuskoko = kasvatuskoko;
        this.alkioidenLkm = 0;
    }    

    public IntJoukko(int kapasiteetti) {
        this(kapasiteetti, OLETUSKASVATUS);
    }    
    
    public IntJoukko() {
        this(OLETUSKASVATUS, OLETUSKASVATUS);
    }

    public boolean lisaa(int luku) {
        if (kuuluu(luku)) {
            return false;
        }

        if (alkioidenLkm == taulukko.length) {
            kasvataTaulukkoa();
        }

        taulukko[alkioidenLkm++] = luku;
        return true;
    }

    public int mahtavuus() {
        return alkioidenLkm;
    }

    @Override
    public String toString() {
        String luvut = "";
        for (int i = 0; i < mahtavuus(); i++) {
            luvut += taulukko[i];
            if (i < mahtavuus() - 1) {
                luvut += ", ";
            }
        }

        return "{" + luvut + "}";
    }

    private void kasvataTaulukkoa() {
        int[] uusi = new int[taulukko.length + kasvatuskoko];

        for (int i = 0; i < taulukko.length; i++) {
            uusi[i] = taulukko[i];

        }

        taulukko = uusi;
    }

    public boolean poista(int luku) {
        int kohdassa = kohdassa(luku);
        if ( kohdassa==-1) return false;

        tiivista(kohdassa);
        
        alkioidenLkm--;
        
        return true;
    }

    public boolean kuuluu(int luku) {
        return kohdassa(luku) != -1;
    }

    private int kohdassa(int luku) {
        for (int i = 0; i < mahtavuus(); i++) {
            if (taulukko[i] == luku) {
                return i;
            }
        }
        return -1;
    }

    private void tiivista(int kohdassa) {
        for( int i= kohdassa; i<alkioidenLkm-1; i++)
            taulukko[i] = taulukko[i+1];
    }    
    
    public int[] toIntArray() {
        int[] kopio = new int[mahtavuus()];
        for (int i = 0; i < kopio.length; i++) {
            kopio[i] = taulukko[i];
            
        }

        return kopio;
    }

    public IntJoukko yhdiste(IntJoukko b) {
        IntJoukko uusi = new IntJoukko();
        
        for (int luku : this.toIntArray()) {
            uusi.lisaa(luku);
        }
        
        for (int luku : b.toIntArray()) {
            uusi.lisaa(luku);
        }        
        
        return uusi;
    }

    public IntJoukko leikkaus(IntJoukko b) {
        IntJoukko uusi = new IntJoukko();
        
        for (int luku : this.toIntArray()) {
            if ( b.kuuluu(luku))
                uusi.lisaa(luku);
        }
        
        return uusi;
    }

    public IntJoukko erotus(IntJoukko b) {
        IntJoukko uusi = new IntJoukko();
        
        for (int luku : this.toIntArray()) {
            uusi.lisaa(luku);
        }
        
        for (int luku : b.toIntArray()) {
            uusi.poista(luku);
        }        
        
        return uusi;
    }
}
