package sovellus;

import sovellus.komennot.*;
import java.util.HashMap;
import java.util.Set;

public class IntJoukkoSovellus  {
    private HashMap<String, Komento> komennot;
    private HashMap<String, IntJoukko> joukot;
    private Lukija lukija;
    
    public IntJoukkoSovellus() {
        joukot = new HashMap<String, IntJoukko>();
        joukot.put("a", new IntJoukko());
        joukot.put("b", new IntJoukko());
        
        komennot = new HashMap<String, Komento>();        
        komennot.put("lisaa", new LisaaJoukkoon(this));
        komennot.put("nayta", new NaytaSisalto(this));
        komennot.put("ohje", new NaytaOhje(this));
        komennot.put("joukot", new NaytaJoukot(this) );
        komennot.put("lopeta", new Lopeta(this) );
        
        lukija = new Lukija();      
    }    
   
    public void kaynnista(){
        suoritaKomento("ohje");
        
        while( true ) {
            String komentoMerkkijonona = lukija.lueMerkkijono("komento: ");
            suoritaKomento(komentoMerkkijonona);
        }
    }
    
    public void suoritaKomento(String komentoMerkkijonona) {
        Komento komento = komennot.get(komentoMerkkijonona);
        if ( komento==null ) {
            System.out.println("tuntematon komento: "+komentoMerkkijonona);
            suoritaKomento("ohje");
            return;
        }
        komento.suorita();
    }   

    // komentojen apumetodit 
    
    public IntJoukko haeJoukko(String joukkoMj){
        return joukot.get(joukkoMj);
    }
  
    public void lisaaJoukko(String joukonNimi, IntJoukko uusiJoukko){
        joukot.put(joukonNimi, uusiJoukko);
    }    
    public Set<String> joukot(){
        return joukot.keySet();
    }
    
    public String lueMerkkijono(String viesti) {
    return lukija.lueMerkkijono(viesti);
    }

    public int lueInt(String viesti) {
        return lukija.lueInt(viesti);
    }

    public Set<String> komennot() {
        return komennot.keySet();
    }
      
}

